%if "0%{?rhel}" >= "06"
%bcond_without repolib
%else
%bcond_with repolib
%endif

%define reltag .redhat_3
%define namedreltag -redhat-3
%global namedversion %{version}%{?namedreltag}

Name:           atinject
Version:        1
Release:        9%{?reltag}%{?dist}
Epoch:          0
Summary:        Dependency injection specification for Java (JSR-330)
Group:          Development/Java
License:        ASL 2.0
URL:            http://code.google.com/p/atinject/
%if 0
svn export -r 86 http://atinject.googlecode.com/svn/tags/1/ atinject-1 && tar cjf atinject-1.tar.bz2 atinject-1
#http://atinject.googlecode.com/svn/tags/javax.inject-tck-1/
%endif
Source0:        atinject-1.tar.bz2
Source1:        http://central.maven.org/maven2/javax/inject/javax.inject-tck/1/javax.inject-tck-1.pom
Patch0:         atinject-vman.patch
Provides:       javax.inject = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
BuildRequires:  java-devel
BuildRequires:  buildnumber-maven-plugin
BuildRequires:  commons-parent
BuildRequires:  jboss-parent
BuildRequires:  junit
BuildRequires:  maven2
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-enforcer-plugin
BuildRequires:  maven-install-plugin
BuildRequires:  maven-jar-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-resources-plugin
BuildRequires:  maven-source-plugin
BuildRequires:  maven-surefire-plugin
BuildRequires:  surefire-junit4
BuildRequires:  zip
BuildArch:      noarch
BuildRoot:      %{_tmppath}/javax.inject-%{namedversion}-%{release}-root

%description
This package specifies a means for obtaining objects in such a way as
to maximize reusability, testability and maintainability compared to
traditional approaches such as constructors, factories, and service
locators (e.g., JNDI). This process, known as dependency injection, is
beneficial to most nontrivial applications.

%package tck
Summary:        TCK for javax.inject
Group:          Development/Java
Provides:       javax.inject-tck = %{epoch}:%{version}-%{release}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       junit
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils

%description tck
TCK for javax.inject.

%package javadoc
Summary:        API documentation for javax.inject
Group:          Documentation
Requires:       jpackage-utils

%description javadoc
API documentation for javax.inject.

%package tck-javadoc
Summary:        API documentation for javax.inject-tck
Group:          Documentation
Requires:       jpackage-utils

%description tck-javadoc
API documentation for javax.inject-tck.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%{__cp} -p %{SOURCE1} javax.inject-tck-%{version}.pom
%patch0 -p1 -b .sav0

%{__mkdir} build/
%{__rm} -r lib/ javadoc/
%{__mkdir} lib/
%{__ln_s} `%{_bindir}/build-classpath junit` lib/junit.jar

%{__perl} -pi -e 's|^VERSION=.*$|VERSION=%{namedversion}|;' build.sh

%build
/bin/sh ./build.sh

%install
%{__rm} -rf %{buildroot}

# jar files
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p build/maven/javax.inject-%{namedversion}.jar %{buildroot}%{_javadir}/javax.inject-%{namedversion}.jar
%{__cp} -p build/maven/javax.inject-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/javax.inject-%{namedversion}-javadoc.jar
%{__cp} -p build/maven/javax.inject-%{namedversion}-sources.jar %{buildroot}%{_javadir}/javax.inject-%{namedversion}-sources.jar
%{__cp} -p build/tck/dist/javax.inject-tck.jar %{buildroot}%{_javadir}/javax.inject-tck-%{namedversion}.jar
%{__cp} -p build/tck/dist/javax.inject-tck-javadoc.zip %{buildroot}%{_javadir}/javax.inject-tck-%{namedversion}-javadoc.jar
%{__cp} -p build/tck/dist/javax.inject-tck-src.zip %{buildroot}%{_javadir}/javax.inject-tck-%{namedversion}-sources.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__cp} -p pom.xml %{buildroot}%{_mavenpomdir}/JPP-javax.inject.pom
%{__cp} -p javax.inject-tck-%{version}.pom %{buildroot}%{_mavenpomdir}/JPP-javax.inject-tck.pom

# depmaps
%add_to_maven_depmap javax.inject javax.inject-tck %{namedversion} JPP javax.inject-tck
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/javax.inject-tck
%add_to_maven_depmap javax.inject javax.inject %{namedversion} JPP javax.inject
[ %{name} = javax.inject ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/javax.inject

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/javax.inject-%{namedversion}
%{__cp} -pr build/javadoc/* %{buildroot}%{_javadocdir}/javax.inject-%{namedversion}
%{__ln_s} javax.inject-%{namedversion} %{buildroot}%{_javadocdir}/javax.inject
%{__mkdir_p} %{buildroot}%{_javadocdir}/javax.inject-tck-%{namedversion}
%{__unzip} -qqo build/tck/dist/javax.inject-tck-javadoc.zip -d %{buildroot}%{_javadocdir}/javax.inject-tck-%{namedversion}
%{__ln_s} javax.inject-tck-%{namedversion} %{buildroot}%{_javadocdir}/javax.inject-tck

%if %with repolib
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export URL=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
export MAVEN_OPTS=
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=%{buildroot}%{_mavenpomdir}/JPP-javax.inject.pom -Dfile=%{buildroot}%{_javadir}/javax.inject-%{namedversion}.jar -Djavadoc=%{buildroot}%{_javadir}/javax.inject-%{namedversion}-javadoc.jar -Dsources=%{buildroot}%{_javadir}/javax.inject-%{namedversion}-sources.jar -Durl=${URL}
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=%{buildroot}%{_mavenpomdir}/JPP-javax.inject-tck.pom -Dfile=%{buildroot}%{_javadir}/javax.inject-tck-%{namedversion}.jar -Djavadoc=%{buildroot}%{_javadir}/javax.inject-tck-%{namedversion}-javadoc.jar -Dsources=%{buildroot}%{_javadir}/javax.inject-tck-%{namedversion}-sources.jar -Durl=${URL}
dir=`pwd`
pushd %{_sourcedir}
%{_bindir}/zip -9 -q ${dir}/javax.inject-javax.inject-%{namedversion}-patches.zip *.patch
%{_bindir}/zip -9 -q ${dir}/javax.inject-javax.inject-%{namedversion}-sources.zip * -x \*.patch
popd
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DgroupId=javax.inject -DartifactId=javax.inject -Dversion=%{namedversion} -Dclassifier=patches -Dpackaging=zip -Dfile=javax.inject-javax.inject-%{namedversion}-patches.zip -Durl=${URL}
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DgroupId=javax.inject -DartifactId=javax.inject -Dversion=%{namedversion} -Dclassifier=sources -Dpackaging=zip -Dfile=javax.inject-javax.inject-%{namedversion}-sources.zip -Durl=${URL}
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%post tck
%update_maven_depmap

%postun tck
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/javax.inject-%{namedversion}.jar
%{_javadir}/javax.inject.jar
%{_javadir}/javax.inject-%{namedversion}-javadoc.jar
%{_javadir}/javax.inject-javadoc.jar
%{_javadir}/javax.inject-%{namedversion}-sources.jar
%{_javadir}/javax.inject-sources.jar
%{_mavenpomdir}/JPP-javax.inject.pom
%{_mavendepmapfragdir}/javax.inject

%files tck
%defattr(0644,root,root,0755)
%{_javadir}/javax.inject-tck-%{namedversion}.jar
%{_javadir}/javax.inject-tck.jar
%{_javadir}/javax.inject-tck-%{namedversion}-javadoc.jar
%{_javadir}/javax.inject-tck-javadoc.jar
%{_javadir}/javax.inject-tck-%{namedversion}-sources.jar
%{_javadir}/javax.inject-tck-sources.jar
%{_mavenpomdir}/JPP-javax.inject-tck.pom
%{_mavendepmapfragdir}/javax.inject-tck

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/javax.inject-%{namedversion}
%{_javadocdir}/javax.inject

%files tck-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/javax.inject-tck-%{namedversion}
%{_javadocdir}/javax.inject-tck

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Thu Jan 31 2013 David Walluck <dwalluck@redhat.com> 0:1-9
- bump to -redhat-3
- use poms from central, and patch them
- fix bad deploy location (maven2-brew not maven2-brew/maven2-brew)
- fix bad deploy command (use the installed jars and poms)
- fix bad depmap name (should be javax.inject)
- fix bad depmap file (tck subpackage needs separate depmap)
- fix bad version
- fix bad release
- fix some build requires
- fix build on RHEL != 6
- add sources and patches zip to repolib

* Fri Aug 31 2012 Vladimir Dosoudil <dosoudil@redhat.com> 0:1-8.2_redhat_2.5
- Fix artifact version suffix
- Use jboss-parent and bom for eap 6.0.1

* Tue Aug 14 2012 Fernando Nasser <fnasser@redhat.com> - 0:1-8.2_redhat_2.4
- Rebuild unsigned

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1-8.2_redhat_1.3
- Rebuild using cache signing

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1-8.2_redhat_1.2
- Rebuild using cache signing

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:1-8.2_redhat_1.1
- Rebuild using cache signing

* Fri Feb 03 2012 Yong Yang <yyang@redhat.com> 0:1-8.2_redhat_1
- Latest vman on-fly, resign

* Tue Sep 20 2011 David Walluck <dwalluck@redhat.com> 0:1-8.1_redhat_1
- Build for werewolf

* Mon Sep 19 2011 David Walluck <dwalluck@redhat.com> 0:1-8
- fix tck depmap entry

* Mon Sep 19 2011 David Walluck <dwalluck@redhat.com> 0:1-7
- use the upstream TCK POM
- TCK groupId on central is wrong

* Mon Sep 19 2011 David Walluck <dwalluck@redhat.com> 0:1-6
- fix Group
- fix POM file name
- install and deploy all tck jars
- add tck and tck-javadoc packages

* Wed Aug 10 2011 David Walluck <dwalluck@redhat.com> 0:1-5
- fix install

* Mon Jun 13 2011 David Walluck <dwalluck@redhat.com> 0:1-4
- fix depmap

* Tue Jun 07 2011 David Walluck <dwalluck@redhat.com> 0:1-3
- add repolib
- export svn from tag
- use build.sh script, not maven

* Thu Dec 29 2010 David Walluck <dwalluck@redhat.com> 0:1-2.20100611svn86
- adapt to JPackage

* Tue Sep 21 2010 Stanislav Ochotnicky <sochotnicky@redhat.com> - 1-1.20100611svn86
- Initial version of the package
